package models

import (
	"gorm.io/gorm"
)

func Paginate(pageNum, pageSize int) func(db *gorm.DB) *gorm.DB {
	return func(db *gorm.DB) *gorm.DB {
		offset := (pageNum - 1) * pageSize
		return db.Offset(offset).Limit(pageSize)
	}
}

func String(query string, arg string) func(db *gorm.DB) *gorm.DB {
	if len(arg) > 0 {
		return func(db *gorm.DB) *gorm.DB {
			return db.Where(query, arg)
		}
	}
	return func(db *gorm.DB) *gorm.DB {
		return db
	}
}

func Bool(query string, arg *bool) func(db *gorm.DB) *gorm.DB {
	if arg != nil {
		return func(db *gorm.DB) *gorm.DB {
			return db.Where(query, *arg)
		}
	}
	return func(db *gorm.DB) *gorm.DB {
		return db
	}
}
